'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getStream = getStream;
exports.createCollector = createCollector;

var _stream = require('stream');

var stream = null;
function getStream() {
  if (!stream) {
    stream = new _stream.Readable();
    // Node.js 0.10 compatibility necessitates this slightly awkward syntax.
    stream._read = function () {};
  }

  return stream;
}

function createCollector(hash) {
  var collect = function (type, id) {
    if (stream) {
      stream.push(hash + ',' + type + ',' + id + '\n');
    }
  };

  return {
    s: function (id) {
      collect('s', id);
    },
    f: function (id) {
      collect('f', id);
    }
  };
}
//# sourceMappingURL=collector.js.map