'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.instrument = instrument;

var _babelCore = require('babel-core');

var _babelPluginTransformEs2015ModulesCommonjs = require('babel-plugin-transform-es2015-modules-commonjs');

var _babelPluginTransformEs2015ModulesCommonjs2 = _interopRequireDefault(_babelPluginTransformEs2015ModulesCommonjs);

var _addInstrumentation = require('./babel-plugins/add-instrumentation');

var _addInstrumentation2 = _interopRequireDefault(_addInstrumentation);

var _generateReportingCode = require('./babel-plugins/generate-reporting-code');

var _generateReportingCode2 = _interopRequireDefault(_generateReportingCode);

var _hashAst = require('./lib/hash-ast');

var _hashAst2 = _interopRequireDefault(_hashAst);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function instrument(_ref) {
  var filename = _ref.filename;
  var input = _ref.code;
  var _ref$inputSourceMap = _ref.inputSourceMap;
  var inputSourceMap = _ref$inputSourceMap === undefined ? null : _ref$inputSourceMap;
  var _ref$collectorModuleI = _ref.collectorModuleId;
  var collectorModuleId = _ref$collectorModuleI === undefined ? 'copenhagen/collector' : _ref$collectorModuleI;
  var _ref$additionalBabelP = _ref.additionalBabelPlugins;
  var additionalBabelPlugins = _ref$additionalBabelP === undefined ? [_babelPluginTransformEs2015ModulesCommonjs2.default] : _ref$additionalBabelP;

  var _transform = (0, _babelCore.transform)(input, {
    babelrc: false,
    filename: filename
  });

  var initialAst = _transform.ast;

  var hash = (0, _hashAst2.default)(filename, initialAst);

  var _transformFromAst = (0, _babelCore.transformFromAst)(initialAst, input, {
    ast: false,
    babelrc: false,
    compact: false,
    filename: filename,
    inputSourceMap: inputSourceMap,
    plugins: [[_addInstrumentation2.default, { collectorModuleId: collectorModuleId }]].concat(_toConsumableArray(additionalBabelPlugins)),
    sourceMaps: true
  });

  var code = _transformFromAst.code;
  var map = _transformFromAst.map;

  var _transform2 = (0, _babelCore.transform)(input, {
    ast: false,
    babelrc: false,
    compact: false,
    filename: filename,
    plugins: [_generateReportingCode2.default].concat(_toConsumableArray(additionalBabelPlugins))
  });

  var reportingCode = _transform2.code;


  return {
    code: code,
    hash: hash,
    map: map,
    reportingCode: reportingCode
  };
}
//# sourceMappingURL=instrument.js.map